package LoginApp;
use Mojo::Base 'Mojolicious', -signatures;

## https://github.com/mojolicious/mojo/tree/master/examples/login
## author: Sebastian Riedel
use LoginApp::Model::Users;

sub startup ($self) {

  # Load configuration from config file
  my $config = $self->plugin('NotYAMLConfig');
  
  # Configure the application
  $self->secrets($config->{secrets});
  $self->plugin('RenderFile');
  $self->helper(users => sub { state $users = LoginApp::Model::Users->new });
  
  # Configure routes here and their corresponding entries in lib/loginApp/Controller/login.pm 
  my $r = $self->routes;
  
  $r->get('/')->to('login#index')->name('index');
  $r->get('/hello')->to('login#hello')->name('hello');
  $r->get('/aboutus')->to('login#aboutus')->name('aboutus');
  $r->get('/findus')->to('login#findus')->name('finds');
  $r->get('/download/*file')->to('login#download');
  
  $r->any('/loginpg')->to('login#loginpg')->name('login');
  ## /:name is a catch-all
  $r->any('/:name')->to('login#none');

## with the implicit helper:'under' any route declare underneath is only assessable via login.
  my $logged_in = $r->under('/loginpg')->to('login#logged_in');
  $logged_in->get('/test1')->to('login#test1');
  
  $r->get('/loginpg/test2')->to('login#test2'); ## other private routes can be added here.
  $r->get('/loginpg/logout')->to('login#logout');
}

1;